/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*macOutx.c   Mac specific calls mostly doing writeouts */
 
#include "MAGE.h"

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writeoutput()************************************************************/
void writeoutput(int kind)
{            /*specific output controlled by kind */
   Point       where;
   SFReply     reply;
   int         h,i,j,n,Lnameflag;
   char        OutStr[256], TestStr[256];
   unsigned long    mage1,mage2,mage3,mage4; /*OSType  4byte integer*/
   unsigned long    pov1,pov2,pov3,pov4; /*OSType  4byte integer*/
   unsigned long    unkn1,unkn2,unkn3,unkn4; /*OSType  4byte integer*/
   FInfo     filefinderinfo;
   StandardFileReply      outputfileinfo;
   
   mage1 = ('M'*16777216); /*shift <<24, doesn't work*/
   mage2 = ('A'*65536);    /*shift <<16, doesn't work*/
   mage3 = ('G'<<8);
   mage4 =  'E';

   pov1 = ('P'*16777216); /*shift <<24, doesn't work*/
   pov2 = ('O'*65536);    /*shift <<16, doesn't work*/
   pov3 = ('V'<<8);
   pov4 =  '3';

   unkn1 = ('?'*16777216); /*shift <<24, doesn't work*/ 
   unkn2 = ('?'*65536);    /*shift <<16, doesn't work*/
   unkn3 = ('?'<<8);
   unkn4 =  '?';

   makecursorwait();

   Lnameflag = 0; /*flag for derived simple name becoming too long*/    
   n = 0;/*keeps track of last directory boundary in full path name*/
   if(Lappleevents)  /*Full Path name likely used for input*/
   {/*isolate local, simple name from Full Path Name*/
      for(i=0;i<256;i++)
      {/*derive output file names from a full kinemage, not an appended file*/
         if(NameStr[i] == '\:') n=i+1;/*platform specific directory deliniator*/
         if(NameStr[i] == '\0') break; 
      }       
   }/*isolate local, simple name from Full Path Name*/
   
   h = 0; /*index for working version of input name*/
   j = 0; /*flag position for a .kin type suffix to be replaced*/
   /*n is either==0, or set to first char of simple name in the Full Path name*/
   for(i=n;i<256;i++) 
   {/*make copy of working part of input file name, flagged for last . */
      TestStr[h] = NameStr[i]; /*this has exact name of current input file*/
      if(TestStr[h] == '.') j = h; /*j indexes last . in TestStr*/
      if(TestStr[h] == '\0') break;
      h++;
   }
   TestStr[255] = '\0';/*safety, name should be a regular C string at this point*/
   if(j >= 251 || (j==0 && i>=251) ) 
   {                        /* j      */
      Lnameflag = 1;    /* .kip\0 */
      TestStr[251] = '\0';  /* 12345  */
      j = 251;
   }
   else if(j==0)
   {
      j = h; /*starting index of .new name suffix */
   }
   inventoutputname(kind,j,TestStr,OutStr,Lnameflag);/*MAGEOUT.c*/
      /* construct output file name from input file name */
      /* add 2,3,or 4 char: .new to input file name */
      /*or replace last .___ with .new*/
      /* no matter what that name is like. new==vw,ksp,kqa,kip,...,kipn*/

   Lnameflag = 1; /*reuse this flag*/
   while(Lnameflag)
   {/*Lnameflag: use standard file selection to confirm output file name*/
      Lnameflag = 0; /*reset this flag to presume useable file name*/
      condition(OutStr);
      condition(word);
        /*MAC: convert output file name from C to Pascal type string */

      /* invoke the standard dialog for finding a file *//*m*//*SFPutFile()*/
      SetPt( &where, 85, 100 ); /*m*//* position of display box on screen */    
      SFPutFile(where,(unsigned char *)word,(unsigned char *)OutStr,NULL,&reply);
      if( reply.good ) 
      {/*file name recognizable*/
         strcpy(OutStr, (const char *)reply.fName);
                /* store file name to be opened later */
         PtoCstr((unsigned char *)OutStr);
         if(strcmp(TestStr,OutStr)==0)
         {/*OutStr == current input name, this is pathelogical*/
            Lnameflag = 1; /*cannot use this file name*/
            sprintf(word,"MUST EDIT THIS NAME");
         }/*or had to be edited to be valid, so pathelogical until changed*/
      }/*file name recognizable*/
      else goto clearwriteconditions; /*canceled file select procedure*/            
   }/*Lnameflag: use standard file selection to confirm output file name*/

   /*succesful file name in hand if reach this point*/
   /*file name recognizable and not pathelogical*/
   /* In newer hierarchical directory system, */
   /* reply.vRefNum holds directory number */
   /*set directory for output file*/
   SetVol( "\p", reply.vRefNum ); /*m*/ /* change to directory of file */

   if(fpout != NULL) fclose(fpout); /* if a previous file is open, close it */
   if ((fpout = fopen(OutStr,"w")) == NULL) 
   {
         sprintf(alertstr,"BEWARE: failure in writing: %s"
                  ,OutStr);
         sprintf(alertstr2,"Current active kinemage file remains: %s"
                  ,NameStr);
         sprintf(alertstr3,"Modified kin file may be defective.");
         DoMageDLOGreport(3); /*mode 2 for abort, 3 for toggle debug*/

       /*sprintf(alertstr," failed to open file: %s          ",OutStr);*/
       /*dosinglealert(0);*/ /*MACDLOG.C*/ /*MPCDLOG.C*/
       goto clearwriteconditions;
   }
   else
   {/*succesful file open*/
      if(kind == 5) 
      {
         FSMakeFSSpec(reply.vRefNum, 0, reply.fName, &(outputfileinfo.sfFile));
         FSpGetFInfo(&(outputfileinfo.sfFile), &filefinderinfo);
               /*change creator to MAGE */
         filefinderinfo.fdCreator = mage1+mage2+mage3+mage4;
         FSpSetFInfo(&(outputfileinfo.sfFile), &filefinderinfo);
      }
      else if(kind == 9)
      { 
         FSMakeFSSpec(reply.vRefNum, 0, reply.fName, &(outputfileinfo.sfFile));
         FSpGetFInfo(&(outputfileinfo.sfFile), &filefinderinfo);
            /*change creator to POV3 */
         filefinderinfo.fdCreator = pov1+pov2+pov3+pov4; 
         FSpSetFInfo(&(outputfileinfo.sfFile), &filefinderinfo);
      }
      else
      { 
         FSMakeFSSpec(reply.vRefNum, 0, reply.fName, &(outputfileinfo.sfFile));
         FSpGetFInfo(&(outputfileinfo.sfFile), &filefinderinfo);
          /*force creator to be ???? NOT just use leftover wordprocesser ID*/
         filefinderinfo.fdCreator = unkn1+unkn2+unkn3+unkn4; 
         FSpSetFInfo(&(outputfileinfo.sfFile), &filefinderinfo);
      }

      if(!routeoutput(kind,OutStr,NameStr)) /*MAGEOUT.c*/
         /*NameStr only used when replacing full kinemage file*/
         goto clearwriteconditions;
         /*treat like canceling file open procedure*/
    }/*succesful file open*/
    makecursoractive();

    if(Lgetnewfile) OpenNewFile(); /*____DLOG.c*/
    else if(LquitMAGE) quitMAGE(); /*MACMENU,MPCMAIN,MUXMMENU*/
    else if(Lclosedrawline) closedrawline(); /*MAGEMENU*/
    else if(Lgetnextkinemage) getnextkinemage(); /*MAGEFILE.C*/
    else if(Lgetkinemagechoice) getkinemagechoice(); /*MAGEUTIL*/
    else  ; /* NOP */
    return; /*successful*/
    
    clearwriteconditions:
     Lgetnewfile=0;
     LquitMAGE=0;
     Lclosedrawline=0;
     Lgetnextkinemage=0;
     Lgetkinemagechoice=0;
    makecursoractive();
    return;  /*unsuccessful*/
}
/*___writeoutput()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writecaption()***********************************************************/
int    writecaption()
{
    int           j=0,icharhit,icharend,icharbegin,k;  
    CharsHandle   mycharhandle; 

            mycharhandle = TEGetText(captText);
            HLock(   (Handle)mycharhandle );
              icharhit = 0;
              icharbegin = 0;
              icharend = (*captText)->teLength;
              if(icharend>0) 
              {/*there is caption*/
                /*space in over the "Kinemage  %d - " characters*/
                /*Mage always puts this on, so always strip it off beginning*/
                while((char)(*(*mycharhandle+icharbegin))!='-') icharbegin++;
                icharhit = icharbegin = icharbegin+2;
               
                
                fprintf(fpout,"@caption%c",EOLOUT); /*990124*/
                
                while(icharhit<icharend)
                {
                  for(j=0;j<254;j++) 
                  {
                    icharhit = icharbegin+j;
                    if(icharhit<icharend)
                    {
                        word[j]=(char)(*(*mycharhandle+icharhit)) ;
                        if(word[j] == EOL) word[j] = EOLOUT;
                    }
                    else 
                    {
                        word[j] = '\0';
                        break;
                    }
                  }
                  word[j+1] = '\0';/*insurance in case doesn't end with break*/
                  fprintf(fpout,"%s",word);
                  icharbegin = icharhit+1;
                }
                /*990124 ends with j & j+1 as '\0' unless text ends on j==254*/
                /*work backwards from j+1 to ensure that last char is an EOLOUT*/
                k = j+1 ;
                while( k>= 0, word[k]=='\0') k--;
                /*k has last effective character of the string*/
                /*if this falls through to k==0, then safety EOLOUT is done*/
                if(word[k] != EOLOUT) fprintf(fpout,"%c",EOLOUT);/*000410*/
              }/*there is caption*/
            HUnlock(   (Handle)mycharhandle );
    return(0);
}
/*___writecaption()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writetext()**************************************************************/
int    writetext()    /*950113*/
{
    int           j=0,icharhit,icharend,icharbegin,k; 
    CharsHandle   mycharhandle; 

            /*begin write text*/
            mycharhandle = TEGetText(textText);
            HLock(   (Handle)mycharhandle );
            icharhit = 0;
            icharbegin = 0;
            icharend = (*textText)->teLength;
            if(icharend>0) 
            {/*there is text*/
                 icharhit = icharbegin;
               
                
                fprintf(fpout,"@text%c",EOLOUT); /*990124*/
                
                while(icharhit<icharend)
                {
                  for(j=0;j<254;j++) 
                  {
                    icharhit = icharbegin+j;
                    if(icharhit<icharend)
                    {
                        word[j]=(char)(*(*mycharhandle+icharhit)) ;
                        if(word[j] == EOL) word[j] = EOLOUT; 
                    }
                    else 
                    {
                        word[j] = '\0';
                        break;
                    }
                  }
                  word[j+1] = '\0';/*insurance in case doesn't end with break*/
                  fprintf(fpout,"%s",word);
                  icharbegin = icharhit+1;
                }
                /*990124 ends with j & j+1 as '\0' unless text ends on j==254*/
                /*work backwards from j+1 to ensure that last char is an EOLOUT*/
                k = j+1 ;
                while( k>= 0, word[k]=='\0') k--;
                /*k has last effective character of the string*/
                /*if this falls through to k==0, then safety EOLOUT is done*/
                if(word[k] != EOLOUT)
                    fprintf(fpout,"%c",EOLOUT);
            }/*there is text*/
            HUnlock(   (Handle)mycharhandle );
            /*end write text*/
    return(0); /*980630*/
}
/*___writetext()_____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/****writequesanswers()*******************************************************/
int    writequesanswers() /*931113*/
{
    int         j,ireturn,iend,Lquestionhere,flowID,Lnew;
    //char        filenameStr[256];/*980630*/
CharsHandle   mycharhandle;
    enum
    {
         skipID = 1
        ,numID = 2
        ,keepID = 3
    };

            mycharhandle = TEGetText(textText);
            HLock(   (Handle)mycharhandle );
            Lquestionhere = 0;
            iQstring = 0;
            iend = (*textText)->teLength;
            flowID = skipID;
            fprintf(fpout,"Questions from file: %s\n",NameStr);
            for(j=0;j<iend;j++)
            {/*scan over all char in text buffer*/
                if(   (char)(*(*mycharhandle+j-4)) == '*'
                   && (char)(*(*mycharhandle+j-3)) == '{'
                   && (char)(*(*mycharhandle+j-2)) == 'Q'
                   && (char)(*(*mycharhandle+j-1)) == ':'
                   && (char)(*(*mycharhandle+j  )) == ' ' )
                {/*find the number*/
                    flowID = numID;
                    Lquestionhere = 1;
                    Lnew = 1;
                }
                if(   (char)(*(*mycharhandle+j-1)) == '}'
                   && (char)(*(*mycharhandle+j  )) == '*' )
                {/*found all the question*/
                    flowID = skipID;
                    if(Lquestionhere)
                    {/*really was a question*/
                         Qstring[iQstring-1] = '\0'; /*lop off bracket*/
                         fprintf(fpout,"Q:%d: %s\n"
                            ,nQuestion,Qstring);
                         fprintf(fpout," A:%d: %s\n"
                            ,nQuestion,thisanswer[nQuestion]);

                    }
                    Lquestionhere = 0;
                    iQstring = 0; /*reset char counter*/
                }

                switch(flowID)
                {/*switch*/
                    case skipID:
                        /* neutral: no flow designated, discard characters */
                    break;
                    case numID:
                        /*when done, getinteger returns as 1  */
                        if( getinteger((char)(*(*mycharhandle+j  )),Lnew) ) /*MAGEINPT.C*/
                        {
                            nQuestion = intpass;
                            /*intpass global to pass int back */
                            flowID=keepID; /* accummulate characters */
                        }
                        Lnew = 0;
                    break;
                    case keepID:
                        Qstring[iQstring++] = (char)(*(*mycharhandle+j  ));
                    break;

                }
            }/*scan over all char in text buffer*/
            HUnlock( (Handle)mycharhandle );
            ireturn = 1;
            fclose(fpout);
    return(ireturn);
}
/*___writequesanswers()_____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#define kSetTextID				'SETT'
#define kPrekinServerSignature	'PKIN'
#define kPrekinServerClass		'PKIN'
#define kNoIdleProc			nil
#define kNoFilterProc		nil
#define kMaxTextSize		255
void DoAppleEvent( AEEventID idToSend, Str255 theText );
/****************************************************/
/*	"ReverSever" source code:  cribbed for PREKIN	*/
/*  "ReverClient" source code: cribbed for MAGE		*/
/*  from Ultimate Mac Programming, Volume I			*/
/*	Copyright 1994, Dave Mark and Donald Olson		*/
/*	This code is free to one and all...				*/
/*		Thank you! DCR								*/	
/****************************************************/

/****doupdate()*********remote update*****************************************/
void doupdate(int putout, char command[256])
{
   Str255 theText;
   int i;
   
   putout = putout; /*980630*/
   CtoPstr(command);
   for(i=0; i<256; i++) theText[i] = command[i];
   PtoCstr((unsigned char *)command);
   
   sprintf(alertstr
      ,"MAGE requested update from remote file attempted on MAC"
       CRLF"%s",command);
   sprintf(alertstr2,"putative theEvent.message== %ld",kSetTextID);
   DoMageDLOGreport(3);
   
   DoAppleEvent(kSetTextID, theText );
   Lupdate = 0;
}
/*___doupdate()______________________________________________________________*/


#ifdef DUMMYCODE
/****doupdatefrompipe()*********remote update*********************************/
void doupdatefrompipe(int putout, char command[256])  /*991213*/
{
   Str255 theText;
   int i;
   
   putout = putout; 
   CtoPstr(command);
   for(i=0; i<256; i++) theText[i] = command[i];
   PtoCstr((unsigned char *)command);
   
   sprintf(alertstr
      ,"MAGE requested update from pipe attempted on MAC"
       CRLF"%s",command);
   sprintf(alertstr2,"putative theEvent.message== %ld",kSetTextID);
   DoMageDLOGreport(3);
   
   DoAppleEvent(kSetTextID, theText );
}
/*___doupdatefrompipe()______________________________________________________*/
#endif /*DUMMYCODE*/
/****DoAppleEvent()***********************************************************/
void DoAppleEvent( AEEventID idToSend, Str255 theText )
{
	AEAddressDesc	targetAddrDesc = {typeNull, nil};
	long			targetSignature = kPrekinServerSignature;
	AppleEvent		event = {typeNull, nil};
	AppleEvent		reply = {typeNull, nil};
	OSErr			err;
	DescType		actualtype;
	Size			actualSize;
	
	err = AECreateDesc( typeApplSignature, (Ptr)(&targetSignature),
				sizeof( targetSignature ), &targetAddrDesc );
	
	if ( err != noErr )/*DoError( "\pError returned by AECreateDesc()..." );*/
	{
        sprintf(alertstr
           ,"Error returned by AECreateDesc()...");
        DoMageDLOGreport(3);
	}
		
		
	err = AECreateAppleEvent( kPrekinServerClass, idToSend,
							&targetAddrDesc, kAutoGenerateReturnID,
							kAnyTransactionID, &event );
	
	if ( err != noErr )/*DoError( "\pError returned by AECreateAppleEvent()..." );*/
	{
        sprintf(alertstr
           ,"Error returned by AECreateAppleEvent()...");
        DoMageDLOGreport(3);
	}
	
	if(*theText) // if we have a string longer than 0
	{
		err = AEPutParamPtr( &event, keyDirectObject, typeChar,
					(Ptr)(&(theText[ 1 ])), theText[ 0 ] );
		
		if ( err != noErr )/*DoError( "\pError returned by AEPutParamPtr()..." );*/
	    {
           sprintf(alertstr
              ,"Error returned by AEPutParamPtr()...");
           DoMageDLOGreport(3);
	    }
	}
	
	err = AESend( &event, &reply, kAEWaitReply + kAECanInteract + kAECanSwitchLayer,
				kAENormalPriority, kAEDefaultTimeout, kNoIdleProc, kNoFilterProc );
	
	if ( err == connectionInvalid )
	{
		/*DoMessage( "\pServer not running..." );*/
        sprintf(alertstr
           ,"Server not running...");
        DoMageDLOGreport(3);
		
		AEDisposeDesc( &targetAddrDesc );
		AEDisposeDesc( &event );
		AEDisposeDesc( &reply );
		return;
	}
	
	if ( err != noErr )/*DoError( "\pError returned by AESend()..." );*/
    {
        sprintf(alertstr
           ,"Error returned by AESend()...");
        DoMageDLOGreport(3);
	}	
	
	err = AEGetParamPtr( &reply, keyDirectObject, typeChar,
			&actualtype, (Ptr)(&(theText[ 1 ])), kMaxTextSize, &actualSize );
			
	theText[0] = actualSize;
	
	if (( err != noErr ) && (err != errAEDescNotFound))
	{
		/*DoError( "\pError returned by AEGetParamPtr()..." );*/
        sprintf(alertstr
           ,"Error returned by AEGetParamPtr()...");
        DoMageDLOGreport(3);
    }
	AEDisposeDesc (&targetAddrDesc);
	AEDisposeDesc (&event);
	AEDisposeDesc (&reply);	
}
/*___DoAppleEvent()__________________________________________________________*/
