#include "MAGE.h"
#include "MAGELIST.h"
#include "MAGEBBOX.h"
#include "MAGEFLAG.h"
/****makebuttonbox()****920605 dcr***********common name: MAC & PC**********/
void makebuttonbox(ControlHandle *buttonbox,int left,int top,int right,int bottom
      ,char name[13],int onoff,int nbox,int nn,int index)
{
    int longeststring = 12;

    /*    &grpbox[ngrp],             */ /*HANDLE: not used */
    /*    brect->left,               */ /*int left:   x */
    /*    i*fontverticalspace+3,     */ /*int top:    y */
    /*    35+longeststring*fontwidth,*/ /*int right:  width in pixels */
    /*    fontverticalspace,         */ /*int bottom: height in pixels */
    /*    groupname[i],              */ /*char name:  name */
    /*    igrp[ngrp][0],             */ /*int onoff:  flag */
    /*    nbox                       */ /*int      :  number of button */
    /*    nn                         */ /*int      :  height in pixels */
    /*    index                      */ /*int      :  index of button */

    *buttonbox = CreateWindow(
        "BUTTON",						/* window control class*/
        name,							/* button label */
        WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | BS_AUTOCHECKBOX,
										/* control styles WS_BORDER |  */
        left,							/* x , can be 10 right of leftmost*/
        nbox*nn,                        /* y */
        25 + longeststring*fontwidth,	/* width in pixels, 10 < dist to slider*/
        nn,								/* height in pixels */
        MageWindow,						/* parent window */
        (HMENU)(MM_BUTTONINDEX),		/* control ID */
        hInst,							/* instance handle */
        0);
    SendMessage(*buttonbox,BM_SETCHECK,onoff,0);
    /*
    sprintf(alertstr,"button# %d, at x, y= %d, %d  %s",nbox,left,nbox*nn,name);
    dosinglealert(); 
    */
}
/*___makebuttonbox()___920605 dcr___________________________________________*/

/***mybuttonspacer()************************common name: MAC & PC************/
void mybuttonspacer(int left,int top ,char name[13]) /*macbxmc.c, mpcextra.c*/
{
    HDC hDCformagewindow = GetDC(MageWindow); /*930915*/
	SetBkMode(hDCformagewindow,TRANSPARENT);
    TextOut(hDCformagewindow,left,top,name,strlen(name));
    ReleaseDC(MageWindow,hDCformagewindow);
}
/*___mybuttonspacer()_______________________________________________________*/

/****getbuttonplace()*920605 dcr**************common name: MAC & PC**********/
void getbuttonplace()
{
    RECT rect; 
    int longeststring = 12;
    /*allow for sliders to right of buttons & button box,name,insets*/

    GetClientRect(MageWindow,&rect);   
    brect.left = rect.right-(SliderWidth+35+longeststring*fontwidth)-RWIDTH;
    brect.right =  rect.right-(SliderWidth-RWIDTH);
    brect.top =    rect.top;
    brect.bottom = rect.bottom;
}
/*___getbuttonplace()_______________________________________________________*/

/****createbuttons()*920605 dcr**********************************************/
void createbuttons(void)
{
    if (!IsIconic(MageWindow)) SetsinGrafWindow();
}
/*___createbuttons()*920605 dcr_____________________________________________*/

/****destroybuttons()******************************************************/
void destroybuttons(HWND button)
{
  DestroyWindow(button);
}
/*___destroybuttons()_____________________________________________________*/

/****destroyallbuttons()*********************************************************/
void destroyallbuttons()  
{
    thisgrupptr = firstgrupptr;
    while(thisgrupptr != NULL)
    {/*groups*/         
        if((thisgrupptr->STATUS & NOBUTTON) == 0) 
        {/*not nobutton group with no buttons*/
            if(thisgrupptr->button != NULL) /*___BBOX.c*/ 
            {
                   destroybuttons(thisgrupptr->button);        
            }
            if((thisgrupptr->STATUS & DOMINANT) == 0)  
            {/*not a dominant group hiding subgroups and lists */
              thissgrpptr = thisgrupptr->firstsgrpptr;
              while(thissgrpptr != NULL)
              {/*subgroups*/
                if((thissgrpptr->STATUS & NOBUTTON) == 0)
                {/*button shown*/
                    if(thissgrpptr->button != NULL) /*___BBOX.c*/ 
                    {
                        destroybuttons(thissgrpptr->button);    
                    }
                }        
                /* 0 recessive, 1 dominant, 2 recessive&&nobutton*/
                /*             , 3 dominant&&nobutton*/  /*960305*/
                if((thissgrpptr->STATUS & DOMINANT) == 0) 
                {/*not hidden lists */
                    /*NOTE: subgroup nobutton allows list buttons*/
                    thislistptr = thissgrpptr->firstlistptr;
                    while(thislistptr != NULL)
                    {/*lists*/
                        if((thislistptr->STATUS & NOBUTTON) == 0)
                        {/*not nobutton*/
                            if(thislistptr->button != NULL) /*___BBOX.c*/ 
                            {
                                destroybuttons(thislistptr->button);
                            }
                        }/*not nobutton*/
                        if(thislistptr == thissgrpptr->lastlistptr)
                            thislistptr=NULL;
                        else thislistptr = thislistptr->nextptr;
                    }/*lists*/
                }/*not hidden lists */
                if(thissgrpptr == thisgrupptr->lastsgrpptr) thissgrpptr=NULL;
                else thissgrpptr = thissgrpptr->nextptr;              
              }/*sets*/
            }/*not a dominant group hiding subgroups and lists */
          }/*not nobutton group with no buttons*/
          thisgrupptr = thisgrupptr->nextptr;              
          if(thisgrupptr != NULL && thisgrupptr == measuregrupptr) 
          {
              thisgrupptr = thisgrupptr->nextptr;
          }

        }/*groups inc markers*/
        if(drawgrupptr && drawgrupptr->button != NULL) /*M___BBOX.c*/ 
        {
            destroybuttons(drawgrupptr->button); 
        }        

        if(nmaster > 0)
        {
            thismasterptr = firstmasterptr;
            while(thismasterptr != NULL)
            {
                 if(thismasterptr->button != NULL) /*M___BBOX.c*/ 
                 {
                      destroybuttons(thismasterptr->button);

                 }
                 thismasterptr = thismasterptr->nextptr;
            }
        }

        if((nanimate > 1)&&(animbboxptr)&&(animbboxptr->button != NULL))
                                             /*M___BBOX.c*/
        {
             destroybuttons(animbboxptr->button);
        }
        if((nnanimate>1)&&(anim2bboxptr)&&(anim2bboxptr->button != NULL))
        {
             destroybuttons(anim2bboxptr->button);
        }
        if(pickbboxptr&&pickbboxptr->button != NULL) /*M___BBOX.c*/ 
        {
            destroybuttons(pickbboxptr->button);
        }        

        if(pickshowbboxptr&&pickshowbboxptr->button != NULL) 
        {
            destroybuttons(pickshowbboxptr->button);
        }        
        if(pickcolorbboxptr&&pickcolorbboxptr->button != NULL) 
        {
            destroybuttons(pickcolorbboxptr->button);
        }        
        if(zclipbboxptr&&zclipbboxptr->button != NULL) /*M___BBOX.c*/ 
        {
            destroybuttons(zclipbboxptr->button);
        }        
        if(measuregrupptr&&measuregrupptr->button != NULL)/*M___BBOX.c*/ 
        {
            destroybuttons(measuregrupptr->button);
        }        
        if(drawlabelsbboxptr&&drawlabelsbboxptr->button != NULL) 
        {
            destroybuttons(drawlabelsbboxptr->button);
        }
        if(drawlinebboxptr&&drawlinebboxptr->button != NULL)       
        {
            destroybuttons(drawlinebboxptr->button);
        }
        if(construct4bboxptr&&construct4bboxptr->button != NULL) 
        {
            destroybuttons(construct4bboxptr->button);
        }
		if(construct5bboxptr&&construct5bboxptr->button != NULL) 
        {
            destroybuttons(construct5bboxptr->button);
        }      
        if(draglinebboxptr&&draglinebboxptr->button != NULL) 
        {
            destroybuttons(draglinebboxptr->button);
        }
        if(monitorbboxptr&&monitorbboxptr->button != NULL) /*M___BBOX.c*/ 
        {
            destroybuttons(monitorbboxptr->button);
        }        
        if(eraselinebboxptr&&eraselinebboxptr->button != NULL) 
        {
            destroybuttons(eraselinebboxptr->button);
        }        
        if(prunebboxptr&&prunebboxptr->button != NULL) /*M___BBOX.c*/ 
        {
            destroybuttons(prunebboxptr->button);
        }        
        if(punchbboxptr&&punchbboxptr->button != NULL)/*M___BBOX.c*/ 
        {
            destroybuttons(punchbboxptr->button);
        }        
        if(undopbboxptr&&undopbboxptr->button != NULL) /*M___BBOX.c*/ 
        {
            destroybuttons(undopbboxptr->button);
        }        
}
/*___destroyallbuttons()________________________________________________________*/
