/*MUXMBBOX.c*/
#include "MAGE.h"  
#include "MAGELIST.h"
#include "MAGEBBOX.h"

/****testbutton()************************************************************/
int    testbutton(ControlHandle it, ControlHandle button)
{
    if( it == button ) return(1);

    else return(0);
}
/*___testbutton()___________________________________________________________*/
/****buttonboxcheck()***********************common name: MAC & PC & MUX ***/
void    buttonboxcheck( ControlHandle button,int itch)
{
          if(button != 0) /*box had been created */

     XmToggleButtonSetState(button,itch,0); /* x mark for itch*/
}
/*___buttonboxcheck()_____________________________________________________*/
          
/****buttonscallback()******************************************************/
void buttonscallback(Widget w, XtPointer clientData, XtPointer callData)
{/*should be a message from a checkbox*/
 /*general callback routine for all check box gadgets*/
    int ion;

    XmToggleButtonCallbackStruct *cbs = 
                (XmToggleButtonCallbackStruct * ) callData;
    
    /*Mac Mage button stuff is in DografContentClick() in macmain.c*/ 
    /*PC  Mage button stuff is in MainWndProc() in mpcmain.c*/ 
    /*PC and MUXM toggle buttons change their own state, Mac's don't */
         
    /*first: get the current toggle state of whoever got clicked */
    ion = cbs->set;
    
    /*during the scan through all boxes, unset those that never show X */
          
    /* beware: check boxes actually defined even when not created,*/
    /* so search by same hierarchy that created them */
          
    buttonboxscan(w, ion);  /*MAGEBBOX.c*/

#ifdef UNIX_PEX
    if(w == buttons[zclipbox])
    {
          setpexclipplanes();  /*MUXPHIG.c*/
    }
    updatevisibility();
#endif /*UNIX_PEX*/

    redrawgraphics(); /*MUXMDRAW.c*/

}/*should be a message from a checkbox*/
/*___buttonscallback______________________________________________________*/

/****makebuttonbox()****************common name: MAC, PC, ESV**************/
void makebuttonbox(Widget *buttonbox,int left,int top,int right,int bottom
      ,char name[13],int onoff,int nbox,int nn,int index)
{
    /*int longeststring;*/
    XFontStruct *localbuttonFont;
    XmFontList   localfontList;

    /*longeststring = 12;*/
   /* buttonbox = buttonbox;*/   /*avoid not used warning */
    left = left; /*offset from drawArea */
    /*top = nn*nbox+MHEIGHT/2;*/ /*offset from form grafwindow top */
    top = nn*(nbox-1)+4+MHEIGHT/2; /*offset from form grafwindow top */
    /* MHEIGHT/2 TERM ALLOWS FOR THE MENU BAR, 4 ALLOWS FOR MENUBAR BORDER */
    right = ZWIDTH; /*offset from form grafwindow right edge*/
    /*bottom = GHEIGHT+MHEIGHT-(top + nn);*/
    /*offset from form grafwindow bottom */
    /*BUT ATTACH BUTTON BOTTOM TO THE TOP OF THE FORM*/

    /*    &grpbox[ngrp],             */ /*HANDLE: not used */
    /*&(thisgrupptr->button)*//*Handle: needed by Mac && X11, not used by PC*/
    /*    brect->left,               */ /*int left:   x */
    /*    i*fontverticalspace+3,     */ /*int top:    y */
    /*    35+longeststring*fontwidth,*/ /*int right:  width in pixels */
    /*    fontverticalspace,         */ /*int bottom: height in pixels */
    /*    groupname[i],              */ /*char name:  name */
    /*    igrp[ngrp][0],             */ /*int onoff:  flag */
    /*    nbox                       */ /*int      :  number of button */
    /*    nn                         */ /*int      :  height in pixels */
    /*    index                      */ /*int      :  index of button */

/*
if(Ltest)
{sprintf(alertstr,"MUXMBBOX/makebuttonbox() make buttonbox for %s\n",name);
 dosinglealert(3);}
*/
/*see /usr/X11R6/lib/X11/fonts/misc for a listing of font sizes*/
/*naming by size seems to work for simple fonts*/
  if(nn < 13 && (localbuttonFont = XLoadQueryFont(dpy, "5x7") ) )
      /*XLoadQueryFont(dpy, "-*-fixed--r-normal--8*") ) )*/
  {
/*    
      if(nbox==1)
printf("Tiny buttons: %d pixels: little font 5x7\n",nn);
*/ 
      localfontList = 
          XmFontListCreate(localbuttonFont, XmSTRING_DEFAULT_CHARSET);
  }

  else if(nn < 15 && (localbuttonFont =
      XLoadQueryFont(dpy, "5x7") ) )
  {
/* 
      if(nbox==1)
printf("Small buttons: %d pixels: little font 5x7\n",nn);
*/ 
      localfontList = 
          XmFontListCreate(localbuttonFont, XmSTRING_DEFAULT_CHARSET);
  }


  else if(nn < 17 && (localbuttonFont =
      XLoadQueryFont(dpy, "7x13") ) )
  {
/* 
      if(nbox==1)
          printf("medium buttons: %d pixels: little font 7x13\n",nn);
*/ 
      localfontList =
          XmFontListCreate(localbuttonFont, XmSTRING_DEFAULT_CHARSET);
  }
  else
  {
/* 
      if(nbox==1)
          printf("Regular buttons: %d pixels: little font \n",nn);
*/ 
      localbuttonFont = buttonFont;  /*globals*/
      localfontList   = fontList;
  }

  n = 0;
  /*left offset changes to distinguish groups,subgroups,lists*/

  XtSetArg(args[n], XmNvisual, magevisual); n++;
  XtSetArg(args[n], XmNdepth, magedepth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  XtSetArg(args[n], XmNbackground, windowbackground); n++;
  /*XtSetArg(args[n], XmNborderColor, windowborder); n++;*/
  XtSetArg(args[n], XmNforeground, windowforeground); n++;
  XtSetArg(args[n], XmNtopShadowColor, topshadowcolor); n++;
  XtSetArg(args[n], XmNbottomShadowColor, bottomshadowcolor); n++;


  XtSetArg(args[n], XmNborderWidth, 0); n++;

  XtSetArg(args[n], XmNmarginWidth, 0); n++;
  XtSetArg(args[n], XmNmarginHeight, 0); n++;
  XtSetArg(args[n], XmNmarginTop, 0); n++;
  XtSetArg(args[n], XmNmarginBottom, 0); n++;

  XtSetArg(args[n], XmNshadowThickness, 0); n++;

  XtSetArg(args[n], XmNrecomputeSize, False); n++;

 /*remove direct reference to drawArea to avoid expose events there*/
 /* XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;*/
 /* XtSetArg(args[n], XmNleftWidget, drawArea); n++;           */
 /* XtSetArg(args[n], XmNleftOffset, left); n++;               */

  XtSetArg(args[n], XmNleftAttachment, XmATTACH_OPPOSITE_FORM); n++;
  XtSetArg(args[n], XmNleftOffset, -BWIDTH -ZWIDTH +left); n++;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNtopOffset, top); n++;

/*seems that inherent size can cause problems, let slop to right */
/*
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightOffset, right); n++;
*/

/*let each button region slop down by font size, cut off by lower one*/
/*  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_OPPOSITE_FORM); n++;*/
  /*XtSetArg(args[n], XmNbottomOffset, -top-nn-6); n++;*/
/*  XtSetArg(args[n], XmNbottomOffset, -top-nn); n++;*/
/*  XtSetArg(args[n], XmNheight, nn); n++;*/ /*DOES NOT WORK*/

  /*XtSetArg(args[n], XmNselectColor, windowborder  ); n++;*/
  XtSetArg(args[n], XmNselectColor, selectcolor); n++;
  XtSetArg(args[n], XmNfillOnSelect, 1 ); n++;
  /*if (buttonFont) { XtSetArg(args[n], XmNfontList, fontList); n++; }*/
  if (localbuttonFont) { XtSetArg(args[n], XmNfontList, localfontList); n++; }

  XtSetArg(args[n], XmNlabelString,
        XmStringCreate(name, XmSTRING_DEFAULT_CHARSET)); n++;

  (*buttonbox) = XtCreateWidget(name, xmToggleButtonWidgetClass,
                                     grafwindow, args, n);
  /* add an activation callback */
  XtAddCallback(*buttonbox,XmNvalueChangedCallback,buttonscallback,NULL);
  XtManageChild(*buttonbox);

  XmToggleButtonSetState(*buttonbox,onoff,0);

}
/*___makebuttonbox()________________________________________________________*/

/***mybuttonspacer()************************common name: MAC, PC, ESV********/
void   mybuttonspacer(int left,int top ,char name[13]) /*macbbox.c mpcbbox.c*/
{
    ;
}
/*___mybuttonspacer()_______________________________________________________*/

/****getbuttonplace()*920605 dcr**************common name: MAC, PC, ESV******/
void   getbuttonplace()
{
    /*Since Motif can set toggle buttons crt drawArea edge, does not need to*/
    /*allow for sliders to right of buttons & button box,name,insets*/
    /* top is 0 for the Form Widget the buttons are in */
    /* bottom is the Widget height! See MUXMINIT.c for grafwindow*/

    brect.left = 0;
    brect.right = 0;
    /*brect.top =   0;*/
    brect.top =   4; /*ALLOWANCE FOR MENUBAR BORDER*/
    brect.bottom = GHEIGHT+(MHEIGHT/2);
    /*brect.bottom = GHEIGHT+MHEIGHT;*/
    /*MHEIGHT includes the MENUBAR + artifactual PEX MESSAGE BOX at bottom*/
}
/*___getbuttonplace()_______________________________________________________*/


/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****placewindowresizemark()*****SetsinGrafWindow() MAGEBBOX.C************/
void    placewindowresizemark()
{
   ;
}
/*___placewindowresizemark()_____________________________________________*/

/****destroybuttons()******************************************************/
void destroybuttons(ControlHandle it)
{
    if (it != 0) 
    {
        XtUnmanageChild(it);
        XtDestroyWidget(it);
    }
}
/*___destroybuttons()_____________________________________________________*/


