/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*MUX_OUT.c */

#include "MAGE.h"
#include "MAGEDLOG.h"
#include "MAGELIST.h"

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writeoutput()************************************************************/
void writeoutput(int kind)
{            /*specific output controlled by kind */
    int    h,i,j,n,ivalid,Lnameflag;
    char        OutStr[256], TestStr[256];

  makecursorwait();
  /*first check that MAGE has valid material for this output*/
  ivalid = 1; /*presume true, then check for a few exceptions*/
  if(kind==3 && Ldrawline==0) ivalid = 0;

  if(ivalid)
  {/*valid output*/   
   
   n = 0; /*use full name in UNIX*/
   h = 0; /*index for working version of input name*/
   j = 0; /*flag position for a .kin type suffix to be replaced*/
   /*n is either==0, or set to first char of simple name in the Full Path name*/
   for(i=n;i<256;i++) 
   {/*make copy of working part of input file name, flagged for last . */
      TestStr[h] = NameStr[i]; /*this has exact name of current input file*/
      if(TestStr[h] == '.') j = h; /*j indexes last . in TestStr*/
      if(TestStr[h] == '\0') break;
      h++;
   }
   TestStr[255]='\0';/*safety, name should be a regular C string at this point*/
   if(j >= 251 || (j==0 && i>=251) ) 
   {                        /* j      */
      Lnameflag = 1;        /* .kip\0 */
      TestStr[251] = '\0';  /* 12345  */
      j = 251;
   }
   else if(j==0)
   {
      j = h; /*starting index of .new name suffix */
   }
   inventoutputname(kind,j,TestStr,OutStr,Lnameflag);/*MAGEOUT.c*/
      /* construct output file name from input file name */
      /* add 2,3,or 4 char: .new to input file name */
      /*or replace last .___ with .new*/
      /* no matter what that name is like. new==vw,ksp,kqa,kip,...,kipn,eps*/

   dooutputfiledialog(kind,OutStr);

  }/*valid output*/
}
/*___writeoutput()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/****dooutputfiledialog()*****************************************************/ 
void dooutputfiledialog(int kind, char OutStr[256])
{
    XmString    xmstring;  /*loads from global word[256] */
    int n;

    /* invoke the standard dialog for finding a file */
    /* "word" holds message, "OutStr" has suggested file name */
    intpass = kind; /*global holds type of output to be done if Callback OK */
    /*always create so will get latest list of files available*/
    /*so have to call XtDestroyWidget() in callbacks*/
    {
        n = 0;
#ifdef MAGECOLORMAP
        XtSetArg(args[n], XmNvisual, magevisual); n++;
        XtSetArg(args[n], XmNdepth, magedepth); n++;
        XtSetArg(args[n], XmNcolormap, colormap); n++;
        XtSetArg(args[n], XmNbackground, windowbackground); n++;
        XtSetArg(args[n], XmNborderColor, windowborder); n++;
        XtSetArg(args[n], XmNforeground, windowforeground); n++;
        XtSetArg(args[n], XmNhighlightColor, highlightcolor); n++;
        XtSetArg(args[n], XmNtopShadowColor, topshadowcolor); n++;
        XtSetArg(args[n], XmNbottomShadowColor, bottomshadowcolor); n++;
        XtSetArg(args[n], XmNselectColor, selectcolor); n++;
        XtSetArg(args[n], XmNtroughColor, troughcolor); n++;
        XtSetArg(args[n], XmNarmColor, armedfillcolor); n++;
#endif /*MAGECOLORMAP*/
 XtSetArg(args[n], XmNvisual, DefaultVisual(dpy,DefaultScreen(dpy))); n++;
 XtSetArg(args[n], XmNdepth,  DefaultDepth(dpy,DefaultScreen(dpy))); n++;
 XtSetArg(args[n], XmNcolormap,  DefaultColormap(dpy,DefaultScreen(dpy))); n++;

 XtSetArg(args[n], XmNeditable, True); n++;

        fileoutdialog = 
              XmCreateFileSelectionDialog(grafwindow,"openFileDialog",args,n);
        XtAddCallback(fileoutdialog,XmNokCallback
                      ,(XtCallbackProc)fileout_OK_CB,NULL);
        XtAddCallback(fileoutdialog,XmNcancelCallback
                      ,(XtCallbackProc)fileout_CANCEL_CB,NULL);
    }/*first time: create dialog*/

     xmstring = XmStringCreateSimple(word);
     XtVaSetValues(fileoutdialog,XmNselectionLabelString,xmstring,NULL);
     XmStringFree(xmstring);
     xmstring = XmStringCreateSimple(OutStr);
     XtVaSetValues(fileoutdialog,XmNtextString,xmstring,NULL);
     XmStringFree(xmstring);

    XtManageChild(fileoutdialog); /*puts the file dialog widget on screen */
    ACTIVE_DLOG = 1; /*Avoids my key capture for graphics control*/
}
/*___dooutputfiledialog()____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/****fileout_OK_CB************************************************************/
XtCallbackProc fileout_OK_CB(Widget w,XtPointer client_data,XtPointer call_data)
/*     Widget w;                       */
/*     caddr_t client_data;            */
/*     XmAnyCallbackStruct *call_data; */
{
  char *filename;
  int  j,kind;
  char  OutStr[256];

  /*See D.A.Young,1994,pg239*/
  
  XmFileSelectionBoxCallbackStruct *cbs =                           
                     (XmFileSelectionBoxCallbackStruct *)call_data; 
  ACTIVE_DLOG = 0;
  XtDestroyWidget(fileoutdialog); 
    /*So next time will create new fileselectiondialogbox including new files*/
  kind = intpass; /*retrieve type of output from global storage*/

  /*retrieve the filename character string from the compound string format*/
  XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &filename);
  for(j=0; j<256; j++)
  {
      OutStr[j] = filename[j];
      if(OutStr[j]=='\0') break;
  }
  if(strcmp(NameStr,OutStr)==0)
  {/*OutStr == current input name, this is pathelogical*/
     sprintf(word,"MUST EDIT THIS NAME");
     dooutputfiledialog(kind, OutStr);
     return(NULL); /*from middle of things*/
  }/*or had to be edited to be valid, so pathelogical until changed*/
  else
  {/*filename OK*/
    makecursorwait(); 
    if(fpout != NULL) fclose(fpout);    
            /* if a previous file is open, close it */
    if ((fpout = fopen(OutStr,"w")) == NULL)  /*c*/
    {
         sprintf(alertstr,"BEWARE: failure in writing: %s"
                  ,OutStr);
         sprintf(alertstr2,"Current active kinemage file remains: %s"
                  ,NameStr);
         sprintf(alertstr3,"Modified kin file may be defective.");
         DoMageDLOGreport(3); /*mode 2 for abort, 3 for toggle debug*/

       /* sprintf(alertstr," failed to open file: %s          ",OutStr);*/
       /* dosinglealert(2);*/ /*___DLOG.C*/ 
        goto clearwriteconditions; /*treat like canceling file open procedure*/
    }
    else
    {/*succesful file open*/
      /*NameStr only used when replacing full kinemage file*/
      if(!routeoutput(kind,OutStr,NameStr)) /*MAGEOUT.c*/
         goto clearwriteconditions;
         /*treat like canceling file open procedure*/
    }/*succesful file open*/
    makecursoractive();
    if(Lgetnewfile) OpenNewFile(); /*____DLOG.c*/
    else if(LquitMAGE) quitMAGE(); /*MACMENU,MPCMAIN,MUXMMENU*/
    else if(Lclosedrawline) closedrawline(); /*MAGEMENU*/
    else if(Lgetnextkinemage) getnextkinemage(); /*MAGEFILE.C*/
    else if(Lgetkinemagechoice) getkinemagechoice(); /*MAGEUTIL*/

    return(NULL);/*successful*/
  }/*filename OK*/
  clearwriteconditions:
     Lgetnewfile=0;
     LquitMAGE=0;
     Lclosedrawline=0;
     Lgetnextkinemage=0;
     Lgetkinemagechoice=0;
  makecursoractive();
  return(NULL);  /*unsuccessful*/
}
/*___fileout_OK_CB___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****fileout_CANCEL_CB********************************************************/
XtCallbackProc fileout_CANCEL_CB(Widget w,XtPointer client_data
                                         ,XtPointer call_data)
{
   ACTIVE_DLOG = 0;
   XtDestroyWidget(fileoutdialog); 
     /*So will create new fileselectiondialogbox to include new files*/
   /*clearwriteconditions:*/
     Lgetnewfile=0; 
     LquitMAGE=0;
     Lclosedrawline=0;
     Lgetnextkinemage=0;
     Lgetkinemagechoice=0;
   makecursoractive();
   return(NULL);
}
/*___fileout_CANCEL_CB_______________________________________________________*/

/****writecaption()***********************************************************/
int    writecaption()
{
    char *   mychar; 
    int  k;
    
    /*begin write caption*/
    mychar = XmTextGetString(captwindow);
    if(strlen(mychar) > 0)
    {/*there is caption*/
       k=0;
       while(mychar[k]!='-') k++;
       k = k+2;

       /*window always seems to get an extra line at the bottom */
       /*as if an extra linefeed is on end of text file, so back off one char*/
       mychar[XmTextGetLastPosition(captwindow)-1] = '\0';/*990209*/

       fprintf(fpout,"@caption\n");
       fprintf(fpout,"%s\n",&mychar[k]);
       XtFree(mychar); /*990209*/
    }/*there is caption*/
    return(0);
}
/*___writecaption()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writetext()**************************************************************/
int    writetext() 
{
    char *   mychar;

    /*begin write text*/
    mychar = XmTextGetString(textwindow);
    /*window always seems to get an extra line at the bottom */
    /*as if an extra linefeed is on end of text file, so back off one char*/
    mychar[XmTextGetLastPosition(textwindow)-1] = '\0';/*990209*/
    fprintf(fpout,"@text\n");
    fprintf(fpout,"%s\n",mychar);
    XtFree(mychar); /*990209*/
    return(0);
}
/*___writetext()_____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

/****writequesanswers()*******************************************************/
int    writequesanswers() /*931113*/
{
    int         j,ireturn,iend,Lquestionhere,flowID,Lnew;
    /*char        filenameStr[256];*/
    char *   mychar; 
    enum
    {
         skipID = 1
        ,numID = 2
        ,keepID = 3
    };

            /*begin scanning text*/
            mychar = XmTextGetString(textwindow);
            Lquestionhere = 0;
            iQstring = 0;
            iend = XmTextGetMaxLength(textwindow);
            flowID = skipID;
            fprintf(fpout,"Questions from file: %s\n",NameStr);
            for(j=0;j<iend;j++)
            {/*scan over all char in text buffer*/
                if(   (char)(*(mychar+j-4)) == '*'
                   && (char)(*(mychar+j-3)) == '{'
                   && (char)(*(mychar+j-2)) == 'Q'
                   && (char)(*(mychar+j-1)) == ':'
                   && (char)(*(mychar+j  )) == ' ' )
                {/*find the number*/
                    flowID = numID;
                    Lquestionhere = 1;
                    Lnew = 1;
                }
                if(   (char)(*(mychar+j-1)) == '}'
                   && (char)(*(mychar+j  )) == '*' )
                {/*found all the question*/
                    flowID = skipID;
                    if(Lquestionhere)
                    {/*really was a question*/
                         Qstring[iQstring-1] = '\0'; /*lop off bracket*/
                         fprintf(fpout,"Q:%d: %s\n"
                            ,nQuestion,Qstring);
                         fprintf(fpout," A:%d: %s\n"
                            ,nQuestion,thisanswer[nQuestion]);

                    }
                    Lquestionhere = 0;
                    iQstring = 0; /*reset char counter*/
                }

                switch(flowID)
                {/*switch*/
                    case skipID:
                        /* neutral: no flow designated, discard characters */
                    break;
                    case numID:
                        /*when done, getinteger returns as 1  */
                        if( getinteger((char)(*(mychar+j)),Lnew))/*MAGEINPT.C*/
                        {
                            nQuestion = intpass;
                            /*intpass global to pass int back */
                            flowID=keepID; /* accummulate characters */
                        }
                        Lnew = 0;
                    break;
                    case keepID:
                        Qstring[iQstring++] = (char)(*(mychar+j  ));
                    break;

                }
            }/*scan over all char in text buffer*/
            ireturn = 1;
            fclose(fpout);
    return(ireturn);
}
/*___writequesanswers()_____________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

